﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Metec.MVBDClient
{
    public partial class FormDrawing : Form
    {
        protected MVBDConnection    _con;


        public FormDrawing()
        {
            InitializeComponent();
        }

        private void FormDrawings_Load(object sender, EventArgs e)
        {
            _con = new MVBDConnection(this);
        }

        private void tmrStatus_Tick(object sender, EventArgs e)
        {
            // Status;
            string status;

            if ( _con.IsConnected() == true )
            {
                status = String.Format("Connected at {0}, Width={1}, Height={2}, Position={3}",  _con.LocalEndPoint, _con.PinCountX, _con.PinCountY, _con.WorkingPosition);
            }
            else
            {
                status = "Not connected";
            }

            if ( status != lblStatus.Text ) lblStatus.Text = status;
        }












        /// <summary>Buttons Draw...</summary>
        private void btnDraw_Click(object sender, EventArgs e)
        {
            // 1. Clear all pins
            if ( chkPinsAutoClear.Checked == true )
            {
                _con.SendPinsClear();
            }


            // 2. Draw something
            Random rnd = new Random();

            if       ( sender == btnPinsDrawRectangle )
            { 
                _con.SendPinsDrawRectangle( rnd.Next(0,20), rnd.Next(0,20),   20,10);
            }

            else  if ( sender == btnPinsDrawLine   )
            {
                _con.SendPinsDrawLine(0, rnd.Next(0,20) , _con.PinCountX-1, rnd.Next(20,40) );
            }

            else  if ( sender == btnPinsDrawPolygon   )
            {
                Point[] points = new Point[4];

                points[0] = new Point( rnd.Next(0,7),   20);
                points[1] = new Point( rnd.Next(10,50), 40);
                points[2] = new Point( rnd.Next(60,65), 20);
                points[3] = new Point( rnd.Next(0,70),   2);

                _con.SendPinsDrawPolygon( points );
            }
            
            else if ( sender == btnPinsDrawCircle )
            {
                _con.SendPinsDrawCircle( rnd.Next(20,40), rnd.Next(20,30), rnd.Next(10,20) );
            }



            // 3. Flush it to show it in the MVBD
            if ( chkPinsAutoFlush.Checked == true )
            {
                _con.SendPinsFlush();
            }

        }





        /// <summary>Send Pins Clear manual</summary>
        private void btnPinsClear_Click(object sender, EventArgs e)
        {
            _con.SendPinsClear();
        }

        /// <summary>Send Pins Flush manual</summary>
        private void btnPinsFlush_Click(object sender, EventArgs e)
        {
            _con.SendPinsFlush();
        }


        /// <summary>Send with Enter</summary>
        private void txtSpeakText_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ( e.KeyChar == 13 )
            {
                btnSpeakText_Click(null,null);
            }
        }

        /// <summary>Speak a short text</summary>
        private void btnSpeakText_Click(object sender, EventArgs e)
        {
            _con.SendSpeakText(txtSpeakText.Text);
        }




        private void btnPinControlsClear_Click(object sender, EventArgs e)
        {
            _con.SendPinControlsClear();
        }

        private void btnPinControlsAddControls_Click(object sender, EventArgs e)
        {

            foreach (Control ctl in Controls)
            {
                object value = ctl.GetType().InvokeMember("Text", System.Reflection.BindingFlags.GetProperty, null, ctl, null);
                string text = value as string;

                _con.SendPinControlsAdd( ctl.Left, ctl.Top, ctl.Width, ctl.Height, text );
            }
        }


















 
    }
}
